/*
 *
 * Copyright (C) 2003 Sadysta ( http://sadysta.ath.cx )
 * Copyright (C) 2007 Tomasz Ostrowski ( http://ostry.w.szu.pl ) - modified from 1.8.9 source
 *
 * This file is part of Free GG.
 *
 * Free GG is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Free GG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Free GG; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "GGToken.h"
#include <stdio.h>
#include <jpeg.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TGGTokenForm *GGTokenForm;
//---------------------------------------------------------------------------
__fastcall TGGTokenForm::TGGTokenForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
extern AnsiString GGDir;
//---------------------------------------------------------------------------
void TokenProc (AnsiString &id)
{
        TClientSocket *S;
        TWinSocketStream *SS;
        AnsiString Request, Reply;
        int read;
        char buf [256];

        S = new TClientSocket (NULL);
        S -> ClientType = ctBlocking;
        S -> Port = 80;
        S -> Host = "appmsg.gadu-gadu.pl";
        S -> Open();

        SS = new TWinSocketStream (S -> Socket, 10000);

        Request = "POST /appsvc/regtoken.asp HTTP/1.0\r\n\
User-Agent: Mozilla/4.0 (compatible; MSIE 5.0; Windows 98)\r\n\
Content-Type: application/x-www-form-urlencoded\r\n\
Content-Length: 0\r\n\
Pragma: no-cache\r\n\
Host: appmsg.gadu-gadu.pl\r\n\r\n";

        SS -> Write (Request.c_str(), Request.Length());

        while ( (read = SS -> Read (buf, sizeof(buf))) > 0 )
        {
                Reply += ((AnsiString)buf).SubString (1, read);
        }

//        ShowMessage (Reply);

        int pos;
        AnsiString cookie;

        pos = Reply.Pos ("60 24 6");
        id = Reply.SubString (pos + 9, Reply.Length() - pos - 9);
        id = id.SubString (1, id.Pos ("\r\n") - 1);

//        WB -> Navigate (WideString("http://appmsg.gadu-gadu.pl/appsvc/tokenpic.asp?tokenid=" + id), NULL, NULL, NULL, NULL);

        delete SS;
        S -> Close();
        delete S;

        S = new TClientSocket (NULL);
        S -> ClientType = ctBlocking;
        S -> Port = 80;
        S -> Host = "appmsg.gadu-gadu.pl";
        S -> Open();

        SS = new TWinSocketStream (S -> Socket, 10000);

        Request = "GET /appsvc/tokenpic.asp?tokenid=" + id + " HTTP/1.0\r\n\
User-Agent: Mozilla/4.0 (compatible; MSIE 5.0; Windows 98)\r\n\
Pragma: no-cache\r\n\r\n";

        SS -> Write (Request.c_str(), Request.Length());

        char *big_buf = NULL;
        int big_buf_size = 0;

        while ((read = SS -> Read (buf, sizeof(buf))) > 0)
        {
                big_buf_size += read;
                if (big_buf_size > 65535) break;
                big_buf = (char*)realloc (big_buf, big_buf_size);
                memcpy (big_buf + big_buf_size - read, buf, read);
        }

        pos = ((AnsiString)big_buf).Pos ("\r\n\r\n");

        FILE *f = fopen ((GGDir + "\\temp\\gg_token_pic.jpg").c_str(), "wb");
        fwrite (big_buf + pos + 3, 1, big_buf_size - pos - 3, f);
        fclose (f);
        free (big_buf);

        delete SS;
        S -> Close();
        delete S;

        TJPEGImage *jpg = new TJPEGImage;
        jpg -> LoadFromFile (GGDir + "\\temp\\gg_token_pic.jpg");
        GGTokenForm -> Image1 -> Picture -> Assign (jpg);
        delete jpg;
}
//---------------------------------------------------------------------------

